----------------------------------------------------------------------------------
-- Create Date:    20:23:05 07/04/2012
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;

entity mem_block is
    generic (
        LEN  : natural := 256;
        BITS : natural := 8
    );
    port (
        clk     : in  std_logic;
        wr      : in  std_logic;
        rd      : in  std_logic;
        addr    : in  integer range 0 to LEN-1;
        rd_data : out unsigned(BITS-1 downto 0);
        wr_data : in  unsigned(BITS-1 downto 0)
    );
end mem_block;

architecture Behavioral of mem_block is
    type mem_type is array (LEN-1 downto 0) of unsigned(BITS-1 downto 0); 
    signal mem : mem_type;
begin

process(clk)
begin
    if rising_edge(clk) then
        if wr = '1' then
            mem(addr) <= wr_data;
        end if;
        
        if rd = '1' then
            rd_data <= mem(addr);
        end if;
    end if;
end process;
    
end Behavioral;

