--------------------------------------------------------------------------------
-- Create Date:   19:33:45 05/14/2012
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;
 
ENTITY test_moving_average IS
END test_moving_average;
 
ARCHITECTURE behavior OF test_moving_average IS
   --Inputs
   signal clk        : std_logic := '0';
   signal reset      : std_logic := '0';
   signal sw         : std_logic := '0';
   signal btn        : std_logic := '0';
   signal mode       : std_logic := '0';
   signal p_mode     : std_logic := '0'; 
   signal adc_signal : std_logic_vector(7 downto 0) := (others => '0');

 	--Outputs
   signal display    : std_logic_vector(6 downto 0);
   signal anode      : std_logic_vector(3 downto 0);
   signal ramp       : std_logic_vector(7 downto 0);
   signal tx         : std_logic;
   signal wr         : std_logic;

   -- Clock period definitions
   constant clk_period : time := 10 ns; 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: entity work.toplevel(Behavioral) PORT MAP (
          clk        => clk,
          reset      => reset,
          sw         => sw,
          btn        => btn,
          mode       => mode,
          p_mode     => p_mode,
          adc_signal => adc_signal,
          display    => display,
          anode      => anode,
          ramp       => ramp,
          tx         => tx,
          wr         => wr
        );

   -- Clock process definitions
   clk_process :process
   begin
		clk <= '0';
		wait for clk_period/2;
		clk <= '1';
		wait for clk_period/2;
   end process;
 
   -- reset
   reset_proc: process
   begin
      reset  <= '1'; 
      wait for clk_period * 100; 
      reset  <= '0';
      wait for clk_period * 100; 
      mode   <= '0';
      p_mode <= '1';
      wait;
   end process;
 
   -- Stimulus process
   stim_proc: process
   begin    
      adc_signal <= std_logic_vector(to_unsigned(32,8));
      wait for 10 ms;
      adc_signal <= std_logic_vector(to_unsigned(190,8));
      wait for 2 ms;
      adc_signal <= std_logic_vector(to_unsigned(32,8));
      wait for 13 ms;
   end process;
END;
