--------------------------------------------------------------------------------
-- Create Date:   19:33:45 05/14/2012
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;
use work.config.all;
 
ENTITY test_toplevel IS
END test_toplevel;
 
ARCHITECTURE behavior OF test_toplevel IS
   --Inputs
        signal clk        : std_logic := '0'; 
        signal reset      : std_logic := '0'; 
        signal sw         : std_logic := '0'; 
        signal sw1        : std_logic := '0'; 
        signal sw2        : std_logic := '0'; 
        signal sw3        : std_logic := '0'; 
        signal sw4        : std_logic := '0'; 
        signal sw5        : std_logic := '0'; 
        signal btn        : std_logic := '0'; 
        signal btn1       : std_logic := '0'; 
        signal btn2       : std_logic := '0'; 
        signal btn3       : std_logic := '0'; 
        signal rx         : std_logic := '1'; 
        signal adc_signal : std_logic_vector (AMPL_BITS-1 downto 0) := (others => '0');
        
    -- Output 
        signal wr         : std_logic;
        signal sync       : std_logic;
        signal out1       : std_logic;
        signal out2       : std_logic;
        signal sclk       : std_logic;
        signal display    : std_logic_vector (7 downto 0);
        signal anode      : std_logic_vector (3 downto 0);
        signal tx         : std_logic;
       

   -- Clock period definitions
   constant clk_period : time := 10 ns; 
BEGIN
	-- Instantiate the Unit Under Test (UUT)
   uut: entity work.toplevel(Behavioral) PORT MAP (
        clk        => clk, 
        reset      => reset, 
        sw         => sw, 
        sw1        => sw1,
        sw2        => sw2, 
        sw3        => sw3, 
        sw4        => sw4, 
        sw5        => sw5, 
        btn        => btn,  
        btn1       => btn1, 
        btn2       => btn2, 
        btn3       => btn3, 
        rx         => rx, 
        adc_signal => adc_signal, 
        
    -- Output 
        wr         => wr, 
        sync       => sync, 
        out1       => out1, 
        out2       => out2, 
        sclk       => sclk, 
        display    => display, 
        anode      => anode, 
        tx         => tx
        );

   -- Clock process definitions
   clk_process :process
   begin
		clk <= '0';
		wait for clk_period/2;
		clk <= '1';
		wait for clk_period/2;
   end process;
 
   -- Stimulus process
   stim_proc: process
   begin	
      reset  <= '1'; 
      wait for clk_period * 100; 
      reset  <= '0';
      wait for clk_period * 100; 
      sw   <= '0';
      
      adc_signal <= std_logic_vector(to_unsigned(32,8));
      wait for 50ms;
      
      adc_signal <= std_logic_vector(to_unsigned(32,8));
      wait for 5 ms;
      adc_signal <= std_logic_vector(to_unsigned(255,8));
      wait for 2 ms;
      adc_signal <= std_logic_vector(to_unsigned(32,8));
      wait for 10 ms;
      adc_signal <= std_logic_vector(to_unsigned(255,8));
      wait for 3 ms;
      adc_signal <= std_logic_vector(to_unsigned(32,8));
      wait for 5 ms;
      
      wait;
   end process;
END;
