LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;
 
ENTITY test_uart_tx IS
END test_uart_tx;
 
ARCHITECTURE behavior OF test_uart_tx IS
   --Inputs
   signal clk       : std_logic := '0';
   signal reset     : std_logic := '0';
   signal baud_tick : std_logic := '0';
   signal tx_start  : std_logic := '0';
   signal dinp      : std_logic_vector(7 downto 0) := (others => '0');

 	--Outputs
   signal tx        : std_logic;
   signal done_tick : std_logic;

   -- Clock period definitions
   constant clk_period : time := 10 ns;
 
BEGIN
     -- Component Instantiation
    uut: entity work.uart_tx(behavioral) port map (
        clk => clk, reset => reset, baud_tick => baud_tick, tx_start => tx_start,
        dinp => dinp, tx => tx, done_tick => done_tick
    );
		  
	freq_gen_unit: entity work.freq_gen(Behavioral)
	port map (
		clk => clk, reset => reset, count => 326, enable => '1', tick => baud_tick
	);

    -- Clock process definitions
    clk_process :process
    begin
		clk <= '0';
		wait for clk_period/2;
		clk <= '1';
		wait for clk_period/2;
    end process;
 
    -- Stimulus process
    stim_proc: process
    begin		
        -- hold reset state for 100 ns.
		reset <= '1';
		wait for 100 ns;	
		reset <= '0';
        wait for clk_period*10;

		wait for 1ms;
		
		dinp <= "11001100";
		tx_start <= '1', '0' after clk_period;
		
		wait for 1ms;
		dinp <= "01010101";
		tx_start <= '1', '0' after clk_period;
		
		wait;
   end process;
END;